#include <stdio.h>


#include "litmus_so.h"
#include "so_qlock.h"

#define CALL(s) { err = s; printf("%s\n\t=> %s\n", #s, lso_error2str(err)); }

lso_global_t __lso_malloc(struct litmus_so* lso, unsigned int size);
void __lso_free(struct litmus_so* lso, lso_global_t ptr);

struct litmus_so  lso;
union {
	struct lso_header hdr;
	char       mem[136];
} obj;

int main(int argc, char** argv) 
{
	struct lso_heap_cell* cell;
	lso_global_t p;
	char* ptr;
	int i, count = 0;

	obj.hdr.heap.start = sizeof(obj.hdr);
	obj.hdr.heap.end   = sizeof(obj.hdr) + 100;
	obj.hdr.heap.free_list_head = obj.hdr.heap.start;
	cell = (struct lso_heap_cell*) (obj.mem + sizeof(struct lso_header));
	cell->prev = obj.hdr.heap.start;
	cell->next = obj.hdr.heap.start;
	cell->size = 100 - sizeof(struct lso_heap_cell);

	lso.base = &obj.hdr;
	
 	p = __lso_malloc(&lso, 50);
	ptr = lso_local_ptr((lso_t) &lso, p);
	for (i = 0; i < 50; i++)
		ptr[i] = 50;

 	p = __lso_malloc(&lso, 25);
	ptr = lso_local_ptr((lso_t) &lso, p);
	for (i = 0; i < 25; i++)
		ptr[i] = 25;


	do {
	__lso_free(&lso, p);

 	p = __lso_malloc(&lso, 10);
	printf("p is %d\n", p);
	ptr = lso_local_ptr((lso_t) &lso, p);
	for (i = 0; i < 10; i++)
		ptr[i] = 10;
	} while (++count < 100);

 	p = __lso_malloc(&lso, 5);
	printf("p is %d\n", p);
//	ptr = lso_local_ptr((lso_t) &lso, p);
//	for (i = 0; i < 10; i++)
//		ptr[i] = 10;


        for (i = 0; i < 100; i++) 
		printf("%3d : %3d\n", i, obj.mem[i+36]);

	return 0;
}
