#include <stdlib.h>
#include <stdio.h>

#include "litmus_so.h"
#include "litmus_pi_sem.h"

#define CALL(s) { err = s; printf("%s\n\t=> %s\n", #s, lso_error2str(err)); }

#define NUM_ITERS 50000

#define NUM_SPIN_ITERS 10000

int main(int argc, char** argv) 
{
	lso_error_t err;
	lso_global_t ptr;
	lso_t lso;
	lso_pi_sem_t lock;
	int count = 0;
	int i, j;
	CALL(lso_create("rt_test_pi_sem.lso", 4, 1000));
	
	CALL(lso_open("rt_test_pi_sem.lso", &lso));
	
	if (err == LSO_OK) {
		printf("my pid is %u\n", lso_get_pid(lso));

		CALL(lso_get_pi_sem(lso, "rt-testlock", &lock));

		for (i = 0; i < NUM_ITERS; i++) {
			lso_pi_semlock(lock);
//			printf("%dL ", lso_get_pid(lso));
//			fflush(stdout);
			for(j = 0; j < NUM_SPIN_ITERS; j++);
//			printf("%dU ", lso_get_pid(lso));
//			fflush(stdout);
			lso_pi_semunlock(lock);
			for(j = 0; j < NUM_SPIN_ITERS; j++);
		}

		while (0) {
			ptr = lso_malloc(lso, rand() % 250);
			count++;
			lso_free(lso, ptr);			
			if (count % 10000 == 0)
				printf("%d: %d\n", lso_get_pid(lso), count);
		}

		CALL(lso_close(&lso));
	}

	return 0;
}
