#include <stdlib.h>
#include <stdio.h>

#include "litmus_so.h"
#include "litmus_srp_sem.h"

#define CALL(s) { err = s; printf("%s\n\t=> %s\n", #s, lso_error2str(err)); }

#define NUM_ITERS 10000

#define NUM_SPIN_ITERS 10000

int main(int argc, char** argv) 
{
	lso_error_t err;
	lso_global_t ptr;
	lso_t lso;
	lso_srp_sem_t lock;
	int count = 0;
	int i, j;
	CALL(lso_create("rt_test_srp_sem.lso", 4, 1000));
	
	CALL(lso_open("rt_test_srp_sem.lso", &lso));
	
	if (err == LSO_OK) {
		printf("my pid is %u\n", lso_get_pid(lso));

		CALL(lso_get_srp_sem(lso, "rt-testlock", &lock));
		
		/* register with SRP sem, use reg_other to test
		 * in reality, we would have to wait for all other
		 * tasks to register before claiming the lock, but
		 * we do not do that here.
		 */
		lso_reg_with_srp_sem(lock);

		for (i = 0; i < NUM_ITERS; i++) {
			lso_srp_semlock(lock);
			printf("%dL ", lso_get_pid(lso));
			for(j = 0; j < NUM_SPIN_ITERS; j++);
			printf("%dU ", lso_get_pid(lso));
			lso_srp_semunlock(lock);
			for(j = 0; j < NUM_SPIN_ITERS; j++);
		}

		while (0) {
			ptr = lso_malloc(lso, rand() % 250);
			count++;
			lso_free(lso, ptr);			
			if (count % 10000 == 0)
				printf("%d: %d\n", lso_get_pid(lso), count);
		}

		CALL(lso_close(&lso));
	}

	return 0;
}
