#include <stdlib.h>
#include <stdio.h>

#include "litmus_so.h"
#include "litmus_qlock.h"

#define CALL(s) { err = s; printf("%s\n\t=> %s\n", #s, lso_error2str(err)); }

int main(int argc, char** argv) 
{
	lso_error_t err;
	lso_global_t ptr;
	lso_t lso;
	lso_qlock_t lock;
	int count = 0;
	CALL(lso_create("test.lso", 4, 1000));
	
	CALL(lso_open("test.lso", &lso));
	
	if (err == LSO_OK) {
		printf("my pid is %u\n", lso_get_pid(lso));

		CALL(lso_create_qlock(lso, "testlock"));
		CALL(lso_get_qlock(lso, "testlock", &lock));

		lso_qlock(lock);
		printf("%d got the lock!\n", lso_get_pid(lso));
		sleep(5);
		printf("%d will release the lock!\n", lso_get_pid(lso));
		lso_qunlock(lock);


		while (0) {
			ptr = lso_malloc(lso, rand() % 250);
			count++;
			lso_free(lso, ptr);			
			if (count % 10000 == 0)
				printf("%d: %d\n", lso_get_pid(lso), count);
		}

		
		CALL(lso_close(&lso));
	}

	return 0;
}
